/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.Dimension2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Point2D;

/**
 *
 * @author Fabi
 */
public class Ball extends GameObject implements Moveable, Scores {

    private Ellipse2D ball;
    private float xVel = 0, yVel = 5;
    private int points = 0;
    private static final int WIDTH = 50;
    private static final int HEIGHT = 50;
    private static final Color COLOR = Color.RED;
    private static final Color TEXT_COLOR = Color.WHITE;
    private boolean startUpdate = false;

    public Ball(int x, int y) {
        ball = new Ellipse2D.Float(x, y, WIDTH, HEIGHT);
        setShape(ball);
        setColor(COLOR);
    }

    @Override
    public void paintObject(Graphics2D g2d) {
        super.paintObject(g2d);
        g2d.setColor(TEXT_COLOR);
        g2d.drawString(String.valueOf(points),
                (int)ball.getCenterX(), (int)ball.getCenterY());
    }

    @Override
    public void updateObject() {
        if (!startUpdate){
            return;
        }
        Dimension2D panelBounds = GameObject.getPanelBounds();
        if (ball.getY() <= 0 || ball.getY() >= panelBounds.getHeight()) {
            yVel = -yVel;
        }
        if (ball.getX() <= 0 || ball.getX() >= panelBounds.getWidth()) {
            xVel = -xVel;
        }
        ball.setFrame(ball.getX() + xVel, ball.getY() + yVel,
                ball.getWidth(), ball.getHeight());
        setShape(ball);
    }

    @Override
    public void mouseClicked(MouseEvent e) {
        startUpdate = true;
    }

    @Override
    public void init() {
        setShape(ball);
    }

    @Override
    public Point2D getPosition() {
        return new Point2D.Double(ball.getCenterX(), ball.getCenterY());
    }

    @Override
    public float getXVelocity() {
        return xVel;
    }

    @Override
    public float getYVelocity() {
        return yVel;
    }

    @Override
    public void setXVelocity(float value) {
        xVel = value;
    }

    @Override
    public void setYVelocity(float value) {
        yVel = value;
    }

    public void addPoints(int value) {
        points += value;
    }

    public void subtractPoints(int value) {
        if (!(value > points)) {
            points -= value;
        } else {
            throw new RuntimeException("Not enough points!");
        }
    }

    public int getPoints() {
        return points;
    }
}
