/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package BallWar;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedHashSet;
import java.util.Set;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;

/**
 *
 * @author Fabi
 */
public class BlockChooserPanel extends JPanel implements ActionListener{

    private static final Class<? extends GameObject> STANDARD_CLASS = ReflectionBlock.class;
    private static Set<Class<? extends GameObject>> classes;
    static{
        classes = new LinkedHashSet<Class<? extends GameObject>>();
        classes.add(ReflectionBlock.class);
        classes.add(RightBlock.class);
        classes.add(LeftBlock.class);
        classes.add(UpBlock.class);
        classes.add(DownBlock.class);
    }
    private Class<? extends GameObject> currentClass = STANDARD_CLASS;

    public static void addClass (Class<? extends GameObject> c){
        classes.add(c);
    }
    public static void removeClass (Class<? extends GameObject> c){
        classes.remove(c);
    }

    public BlockChooserPanel (){
        setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
        for (Class<? extends GameObject> c : classes){
            JButton b = new JButton(c.getSimpleName());
            b.setActionCommand(c.getCanonicalName());
            b.addActionListener(this);
            add(b);
        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        try{
        String name = e.getActionCommand();
        currentClass = (Class<? extends GameObject>) Class.forName(name);
        } catch (Exception ex){
            throw new RuntimeException("Couldn't find class!", ex);
        }
    }

    /**
     * @return the current class
     */
    public Class<? extends GameObject> getCurrentClass() {
        return currentClass;
    }

    public void setCurrentClass (Class<? extends GameObject> c){
        currentClass = c;
    }
    
}
