/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.image.BufferedImage;
import javax.swing.JPanel;
import javax.swing.Timer;

/**
 *
 * @author Fabi
 */
public class GamePanel extends JPanel {

    private BufferedImage buffer;
    private final Timer t;

    private static class GameAdapter extends MouseAdapter {

        @Override
        public void mouseClicked(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseClicked(e);
                }
            });
        }

        @Override
        public void mouseDragged(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseDragged(e);
                }
            });
        }

        @Override
        public void mouseEntered(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseEntered(e);
                }
            });
        }

        @Override
        public void mouseExited(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseExited(e);
                }
            });
        }

        @Override
        public void mouseMoved(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseMoved(e);
                }
            });
        }

        @Override
        public void mousePressed(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mousePressed(e);
                }
            });
        }

        @Override
        public void mouseReleased(final MouseEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseReleased(e);
                }
            });
        }

        @Override
        public void mouseWheelMoved(final MouseWheelEvent e) {
            GameObject.doForAll(new GameObject.ForEachMethod() {

                @Override
                public void doForObject(GameObject o) {
                    o.mouseWheelMoved(e);
                }
            });
        }
    }

    public GamePanel(Dimension d) {
        super(true);
        GameObject.setPanelBounds(d);
        buffer = new BufferedImage(d.width, d.height,
                BufferedImage.TYPE_INT_RGB);
        width = d.width;
        height = d.height;
        setPreferredSize(d);
        MouseAdapter adapter = new GameAdapter();
        // mouse listeners
        this.addMouseListener(adapter);
        this.addMouseWheelListener(adapter);
        this.addMouseMotionListener(adapter);
        // timer for repainting (20 FPS)
        t = new Timer(50, new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                repaint();
            }
        });
        t.start();
    }
    private final int width;
    private final int height;

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d = buffer.createGraphics();
        // clear backbuffer
        g2d.clearRect(0, 0, width, height);
        // paint objects in backbuffer
        GameObject.paintAll(g2d, width, height);
        g2d.dispose();
        // paint backbuffer
        g.drawImage(buffer, 0, 0, null);
        // update objects
        GameObject.updateAll();
    }

    @Override
    public void removeNotify() {
        super.removeNotify();
        t.stop();
    }
}
