/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.geom.Dimension2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.io.Serializable;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author Fabi
 */
public class Level implements Serializable, Iterable<GameObject>{

    private List<Point> points = new LinkedList<Point>();
    private List<Block> blocks = new LinkedList<Block>();
    private StartPoint startPosition;
    private EndRect endRect;
    private Dimension2D size;
    private String name;
    private int minPoints;

    public void addPoint (Point p){
        points.add(p);
    }
    public void removePoint (Point p){
        points.remove(p);
    }
    public GameObject findNearest (final Point2D pos){
        return Collections.max(points, new Comparator<GameObject> () {

            public int compare(GameObject o1, GameObject o2) {
                Point2D pos1 = o1.getPosition();
                Point2D pos2 = o2.getPosition();
                double distance1 = pos1.distance(pos);
                double distance2 = pos2.distance(pos);
                return (int) (distance1 - distance2);
            }
        });
    }
    public void addBlock (Block b){
        blocks.add(b);
    }
    public void removeBlock (Block b){
        blocks.remove(b);
    }
    /**
     * @return the size
     */
    public Dimension2D getSize() {
        return size;
    }

    /**
     * @param size the size to set
     */
    public void setSize(Dimension2D size) {
        this.size = size;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    public Iterator<GameObject> iterator() {
        List<GameObject> objects = new LinkedList<GameObject>(blocks);
        objects.addAll(points);
        objects.add(endRect);
        objects.add(startPosition);
        return objects.iterator();
    }

    /**
     * @return the startPosition
     */
    public StartPoint getStartPosition() {
        return startPosition;
    }

    /**
     * @param startPosition the startPosition to set
     */
    public void setStartPosition(Point2D startPosition) {
        this.startPosition = new StartPoint(startPosition);
    }

    /**
     * @return the endRect
     */
    public EndRect getEndRect() {
        return endRect;
    }

    /**
     * @param endRect the endRect to set
     */
    public void setEndRect(Rectangle2D endRect) {
        this.endRect = new EndRect(endRect);
    }

    /**
     * @return the minPoints
     */
    public int getMinPoints() {
        return minPoints;
    }

    /**
     * @param minPoints the minPoints to set
     */
    public void setMinPoints(int minPoints) {
        this.minPoints = minPoints;
    }

}
