/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.Dimension2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

/**
 *
 * @author Fabi
 */
public class LevelBuilder extends Application {

    private JDialog dialog;

    private class LevelBuilderPlayer extends Player { // also points can added

        public LevelBuilderPlayer(BlockChooserPanel bcp) {
            super(bcp);
        }

        @Override
        public void mouseReleased(MouseEvent e) {
            if (setEndRect) {
                GameObject.addLater(new EndRect(getBounds2D()));
                setShape(null);
                setEndRect = false;
            } else {
                super.mouseReleased(e);
            }
        }

        @Override
        public void mouseClicked(MouseEvent e) {
            if (setStartPoint) {
                GameObject.addLater(new StartPoint(e.getPoint()));
                setStartPoint = false;
            } else if (chooserPanel.getCurrentClass().equals(Point.class)) {
                GameObject point = new Point(e.getX(), e.getY());
                GameObject.addLater(point);
            }
        }

        @Override
        public void mouseWheelMoved(MouseWheelEvent e) {
            final Point2D p = e.getPoint();
            final MutablePrimitive<GameObject> obj = new MutablePrimitive<GameObject>(null);
            doForAll(new ForEachMethod() {

                public void doForObject(GameObject o) {
                    if (o.contains(p)) {
                        obj.setObject(o);
                    }
                }
            });
            if (obj.getObject() != null) {
                GameObject.eraseLater(obj.getObject());
            }
        }
    }

    private class SaveListener implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            LevelList list;
            if (GameStarter.levelFile.exists()) {
                list = LevelList.loadLevelList(GameStarter.levelFile);
            } else {
                list = new LevelList();
            }
            final Level l = new Level();
            GameObject.doForAll(new GameObject.ForEachMethod() {

                public void doForObject(GameObject o) {
                    if (o instanceof Block) {
                        l.addBlock((Block) o);
                    } else if (o instanceof Point) {
                        l.addPoint((Point) o);
                    }
                }
            });
            l.setName(name);
            l.setSize(size);
            final MutablePrimitive<Point2D> startPoint = new MutablePrimitive<Point2D>(null);
            GameObject.doForAll(new GameObject.ForEachMethod() {

                public void doForObject(GameObject o) {
                    if (o instanceof StartPoint) {
                        startPoint.setObject(o.getPosition());
                    }
                }
            });
            final MutablePrimitive<Rectangle2D> endRect = new MutablePrimitive<Rectangle2D>(null);
            GameObject.doForAll(new GameObject.ForEachMethod() {

                public void doForObject(GameObject o) {
                    if (o instanceof EndRect) {
                        endRect.setObject(o.getBounds2D());
                    }
                }
            });
            if (endRect.getObject() == null || startPoint.getObject() == null) {
                JOptionPane.showMessageDialog(null,
                        "Sie müssen den Start und das Ende setzen!",
                        "Fehler", JOptionPane.WARNING_MESSAGE);
                return;
            }
            l.setEndRect(endRect.getObject());
            l.setStartPosition(startPoint.getObject());
            l.setMinPoints(minPoints);
            list.addLevel(l);
            LevelList.saveLevelList(list, GameStarter.levelFile);
            GameObject.eraseAll();
            frame.setVisible(false);
        }
    }
    private JPanel panel;
    protected Dimension2D size;
    protected String name;
    protected int minPoints;
    private JTextField nameTxt;
    private JTextField heightTxt;
    private JTextField widthTxt;
    private JTextField minPointsTxt;
    private JFrame frame;
    protected boolean setStartPoint = false;
    protected boolean setEndRect = false;

    @Override
    protected void init() {
        // add classes
        BlockChooserPanel.addClass(Point.class);
        BlockChooserPanel.addClass(DeadlyBlock.class);
        panel = new JPanel();
        panel.setLayout(new BorderLayout());
        BlockChooserPanel blockChooserPanel = new BlockChooserPanel();
        panel.add(blockChooserPanel, BorderLayout.NORTH);
        JPanel pointPanel = new JPanel();
        pointPanel.setLayout(new BoxLayout(pointPanel, BoxLayout.Y_AXIS));
        JButton startPointButton = new JButton("Startpunkt festlegen");
        startPointButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                setStartPoint = true;
            }
        });
        pointPanel.add(startPointButton);
        JButton endRectButton = new JButton("Ende festlegen");
        endRectButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                setEndRect = true;
            }
        });
        pointPanel.add(endRectButton);
        panel.add(pointPanel, BorderLayout.EAST);
        getLevelData();
        if (size == null) {
            return;
        }
        GamePanel gp = new GamePanel(new Dimension((int) size.getWidth(), (int) size.getHeight()));
        JScrollPane scroller = new JScrollPane(gp);
        panel.add(scroller, BorderLayout.CENTER);
        GameObject.addLater(new LevelBuilderPlayer(blockChooserPanel));
        JButton saveButton = new JButton("Speichern");
        saveButton.addActionListener(new SaveListener());
        panel.add(saveButton, BorderLayout.SOUTH);
    }

    @Override
    protected void start() {
        frame = new JFrame("LevelBuilder");
        frame.add(panel);
        frame.pack();
        frame.setLocationByPlatform(true);
        frame.addWindowListener(new WindowAdapter() {

            @Override
            public void windowClosing(WindowEvent e) {
                exitApplication();
            }
        });
        frame.setVisible(true);
    }

    protected void getLevelData() {
        nameTxt = new JTextField();
        heightTxt = new JTextField();
        widthTxt = new JTextField();
        minPointsTxt = new JTextField();
        dialog = new JDialog();
        dialog.setLayout(new BorderLayout());
        dialog.setModal(true);
        JPanel p = new JPanel();
        dialog.add(p, BorderLayout.CENTER);
        p.setLayout(new GridLayout(4, 2));
        p.add(new JLabel("Breite: "));
        p.add(widthTxt);
        p.add(new JLabel("Höhe: "));
        p.add(heightTxt);
        p.add(new JLabel("Name: "));
        p.add(nameTxt);
        p.add(new JLabel("Min. Punkte: "));
        p.add(minPointsTxt);
        JButton ok = new JButton("OK");
        ok.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                name = nameTxt.getText();
                try {
                    int w = Integer.parseInt(widthTxt.getText());
                    int h = Integer.parseInt(heightTxt.getText());
                    size = new Dimension(w, h);
                    minPoints = Integer.parseInt(minPointsTxt.getText());
                } catch (NumberFormatException ex) {
                    JOptionPane.showMessageDialog(null,
                            "Fehler: Ungültige Angabe(keine Zahl)!", "Fehler",
                            JOptionPane.ERROR_MESSAGE);
                    exitApplication();
                }
                dialog.setVisible(false);
            }
        });
        dialog.add(ok, BorderLayout.SOUTH);
        dialog.addWindowListener(new WindowAdapter() {

            @Override
            public void windowClosing(WindowEvent e) {
                exitApplication();
            }
        });
        dialog.pack();
        dialog.setVisible(true);
    }

    @Override
    protected void exit() {
        if (dialog != null) {
            dialog.dispose();
        }
        if (frame != null) {
            frame.dispose();
        }
        BlockChooserPanel.removeClass (DeadlyBlock.class);
        BlockChooserPanel.removeClass(Point.class);
        GameObject.eraseAll();
    }
}
