/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author Fabi
 */
public class LevelList implements Serializable {

    private List<Level> levels = new LinkedList<Level>();

    public void addLevel(Level l) {
        Level lvl = null;
        // no levels with the same name
        for (Level currLevel : levels){
           if (currLevel.getName().equals(l.getName())) {
               lvl = currLevel;
           }
        }
        if (lvl != null){
            levels.remove(lvl);
        }
        levels.add(l);
    }

    public void removeLevel(Level l) {
        levels.remove(l);
    }
    public List<Level> getLevels (){
        return levels;
    }
    public static void saveLevelList(LevelList l, File f) {
        ObjectOutputStream out = null;
        try {
            out = new ObjectOutputStream(new FileOutputStream(f));
            out.writeObject(l);
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (out != null) {
                try {
                    out.close();
                } catch (Exception ex) {
                }
            }
        }
    }

    public static LevelList loadLevelList(File f) {
        if (!f.exists()) {
            throw new RuntimeException("File doesn't exist!");
        }
        ObjectInputStream in = null;
        LevelList l = null;
        try {
            in = new ObjectInputStream(new FileInputStream(f));
            l = (LevelList) in.readObject();
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (in != null) {
                try {
                    in.close();
                } catch (Exception ex) {
                }
            }
        }
        return l;
    }
}
