/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package BallWar;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

/**
 *
 * @author Fabi
 */
public class Player extends GameObject {

    private Point2D start;
    private Rectangle2D rect;
    protected BlockChooserPanel chooserPanel;

    public Player (BlockChooserPanel panel){
        chooserPanel = panel;
        setColor(Color.LIGHT_GRAY);
    }   

    @Override
    public void mousePressed(MouseEvent e) {
        start = e.getPoint();
        rect = new Rectangle2D.Double(start.getX(), start.getY(), 0, 0);
        setShape(rect);
    }

    @Override
    public void mouseReleased(MouseEvent e) {
        try{
            GameObject obj = chooserPanel.getCurrentClass().newInstance();
            if (!(obj instanceof Block)){
                return;
            }
            obj.init();
            obj.setShape(rect);
            GameObject.addLater(obj);
        } catch (Exception ex){
            throw new RuntimeException("Can't instance Block!", ex);
        } finally {
            rect = null;
            setShape(null);
        }
    }

    @Override
    public void mouseDragged(MouseEvent e) {
        rect.setFrameFromDiagonal(start, e.getPoint());
        setShape(rect);
    }

    @Override
    public void updateObject() {
    }

    @Override
    public void init() {
        setShape(null);
        setColor(Color.LIGHT_GRAY);
    }
}
